/*$$$LICENCE_NORDIC_STANDARD<2016>$$$*/

 /**
 *
 * @defgroup audio_coder Audio coder
 * @{
 * @ingroup  MOD_AUDIO
 * @brief Audio coder functions.
 */

#ifndef __DRV_AUDIO_CODEC_H__
#define __DRV_AUDIO_CODEC_H__

#include "nrf_cli.h"
#include "m_audio.h"

/**@brief CLI subcommands of the codec */
extern const nrf_cli_cmd_entry_t drv_audio_codec_subcmds;

/**@brief Initialize the codec. */
void drv_audio_codec_init(void);

/**@brief Function that encodes one audio frame. The number of input samples and the size of the encoded output depend on the selected codec type.
 */
void drv_audio_codec_encode(int16_t *raw_samples, m_audio_frame_t *p_frame);

#endif
